package cn.sh.stc.sict.theme.hphy.service;

import cn.sh.stc.sict.cloud.common.core.dto.*;
import cn.sh.stc.sict.cloud.upms.dto.CurrentUser;
import cn.sh.stc.sict.theme.hphy.model.HphyPatientBase;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * 患者基本信息
 *
 * @author F_xh
 * @date 2020-09-29 15:05:29
 */
public interface HphyPatientBaseService extends IService<HphyPatientBase> {
    HphyPatientBase getByOpenId(String openId);

    HphyPatientBase getByPhone(String phone, Boolean flag);

    HphyPatientBase saveSSbInfo(CurrentUser current, WDUserInfo userInfo, List<WDUserCardInfo> cardList);

    /**
     * 保存香山中医医院公众号用户
     *
     * @param current  当前用户
     * @param userInfo 公众号用户详情
     * @return XSZYUserInfo {@link XSZYUserInfo}
     */
    HphyPatientBase saveWoaXszyInfo(CurrentUser current, XSZYUserInfo userInfo);

    /**
     * 保存中智公众号用户信息
     *
     * @param current  当前用户
     * @param userInfo 公众号用户详情
     * @return XSZYUserInfo {@link WOAZzUserInfo}
     */
    HphyPatientBase saveWoaZzInfo(CurrentUser current, WOAZzUserInfo userInfo);

    /**
     * 保存万达公众号用户信息
     *
     * @param current  当前用户
     * @param userInfo 公众号用户详情
     * @return XSZYUserInfo {@link WOAWDUserInfo}
     */
    HphyPatientBase saveWoaWdInfo(CurrentUser current, WOAWDUserInfo userInfo);

    void savePatient(HphyPatientBase patient);

    HphyPatientBase getCurrentBase();
}

